/*******************************************************************************

		AXC-SI0x Series Sample Program for Windows Mobile-based
						Pocket PC 2002 / 2003

--------------------------------------------------------------------------------
  Compiler : Microsoft eMbedded Visual C++ 4.0 SP3
			 (Pocket PC 2003 SDK is required.)

  (C)2003-2004 ADTEK System Science Co.,Ltd.

*******************************************************************************/
#include	<windows.h>
#include 	<commdlg.h>
#include 	<stdio.h>
#include 	<stdlib.h>
#include	<string.h>
#include	<TCHAR.H>
#include	<aygshell.h>
#include	"resource.h"
#include	"import.h"

HINSTANCE 	hInst;										// AvP[VCX^Xnh
TCHAR		szAppName[] = TEXT("AXC-SI0x SAMPLE");		// AvP[V
TCHAR		szPortName[32] = TEXT("COM");				// bnl|[g

HANDLE		hCom;										// bnl|[gnh
DCB			stDcb;										// cba\

BOOL 		fThread;									// XbhtO
HANDLE 		hThread;									// Xbhnh
DWORD 		ThreadId;									// Xbhhc
long		lPortNumber;								// ATCꂽCOM|[gԍ

#define		WM_RECVDATA		(WM_USER + 1001)

#define		RECV_BUF_MAX	256
#define		STR_BUF_MAX		1024
BYTE		byRecvBuf[RECV_BUF_MAX];					// Mf[^obt@
TCHAR		strRecvBuf[STR_BUF_MAX];

#define		SEND_BUF_MAX	256
BOOL		fSendFlag;									// MtO
BYTE		bySendBuf[SEND_BUF_MAX];					// Mf[^obt@
TCHAR		strSendBuf[SEND_BUF_MAX+1];

BOOL		fFirstSetting;
int			iSetting[5];

/*******************************************************************************
								ʐMXbh

	hwnd : ޳
߂l	
	0
*******************************************************************************/
DWORD CommThread( HWND hwnd )
{
    COMSTAT stat;
	DWORD	err;
	DWORD	rwbyte;
	DWORD	t;
	int		cnt;
	int		i;
	BYTE	*rbuf;

	cnt = 0;
	while(fThread == TRUE)
	{
		// M`FbN
		if(fSendFlag == 1)
		{
			// f[^M
			WriteFile(hCom,bySendBuf,strlen(bySendBuf),&rwbyte,NULL);
			fSendFlag = FALSE;
		}

		// ʐMG[NAʐMԎ擾
		if(ClearCommError(hCom , &err , &stat) == TRUE)
		{	
			if(stat.cbInQue > 0)
			{
				for(i = 0;i < (int)stat.cbInQue;i++)
				{
					// Mf[^Ǐo
					ReadFile(hCom,&byRecvBuf[cnt],1,&rwbyte,NULL);
					cnt++;
					if(cnt >= RECV_BUF_MAX)
					{
						rbuf = (BYTE *)GlobalAlloc(GPTR,cnt);
						memcpy(rbuf,byRecvBuf,cnt);
						// Mf[^CEBhE֒ʒm
						PostMessage(hwnd,WM_RECVDATA,(WPARAM)rbuf,cnt);
						cnt = 0;
					}
				}
				t = GetTickCount();
			}
			else
			{
				// LN^ԃ^CAEg`FbN
				if((GetTickCount() - t) >= 250)
				{
					if(cnt > 0)
					{
						rbuf = (BYTE *)GlobalAlloc(GPTR,cnt);
						memcpy(rbuf,byRecvBuf,cnt);
						// Mf[^CEBhE֒ʒm
						PostMessage(hwnd,WM_RECVDATA,(WPARAM)rbuf,cnt);
						cnt = 0;
					}
					t = GetTickCount();
				}
			}
		}

		// Wait
		Sleep(1);
	}
	return 0;
}


														
/*******************************************************************************
						ʐMݒ_CAOvV[W

	hwnd		: EBhEnh
	uMessage	: bZ[W
	wParam		: ǉ
	lParam		: ǉ
߂l	
*******************************************************************************/
LRESULT CALLBACK SetParamDlgProc( HWND hwnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{
	int		i;
	TCHAR	StrPort[32] = TEXT("Port Assignment >> ");
	LPTSTR	StrBaud[] =
	{
		TEXT("110")		,TEXT("300")	,TEXT("600")	,TEXT("1200"),
		TEXT("2400")	,TEXT("4800")	,TEXT("9600")	,TEXT("14400"),
		TEXT("19200")	,TEXT("38400")	,TEXT("57600")	,TEXT("115200"),
		0
	};
	DWORD	dwBaud[] = 
	{
		CBR_110			,CBR_300		,CBR_600		,CBR_1200,
		CBR_2400		,CBR_4800		,CBR_9600		,CBR_14400,
		CBR_19200		,CBR_38400		,CBR_57600		,CBR_115200
	};

	LPTSTR	StrDatBit[] = 
	{
		TEXT("5")	,TEXT("6")	,TEXT("7")	,TEXT("8"),
		0
	};
	BYTE	byDatBit[] = 
	{
		5			,6			,7			,8
	};

	LPTSTR	StrParity[] = 
	{
		TEXT("None")	,TEXT("Even")	,TEXT("Odd"),
		0
	};
	BYTE	byParity[] = 
	{
		NOPARITY		,EVENPARITY		,ODDPARITY
	};
	

	LPTSTR	StrStpBit[] = 
	{
		TEXT("1")	,TEXT("1.5")	,TEXT("2"),
		0
	};
	BYTE	byStpBit[] = 
	{
		ONESTOPBIT	,ONE5STOPBITS	,TWOSTOPBITS
	};
		
	LPTSTR	StrFlow[] = 
	{
		TEXT("None"),TEXT("Xon/Xoff"),TEXT("Hardware"),
		0
	};

	switch(uMessage)
	{
		case WM_INITDIALOG:
			// ATCĂbnl|[g\
			_tcscat( StrPort, szPortName );
			SetDlgItemText( hwnd, IDE_COMPORT, StrPort );

			// R{{bNXɃp[^ݒ
			for( i = 0; StrBaud[i] != 0; i++ )		SendDlgItemMessage( hwnd, IDC_BAUD, CB_ADDSTRING, 0, (LPARAM)StrBaud[i] );
			for( i = 0; StrDatBit[i] != 0; i++ )	SendDlgItemMessage( hwnd, IDC_DATABIT, CB_ADDSTRING, 0, (LPARAM)StrDatBit[i] );
			for( i = 0; StrParity[i] != 0; i++ )	SendDlgItemMessage( hwnd, IDC_PARITY, CB_ADDSTRING, 0, (LPARAM)StrParity[i] );
			for( i = 0; StrStpBit[i] != 0; i++ )	SendDlgItemMessage( hwnd, IDC_STOPBIT, CB_ADDSTRING, 0, (LPARAM)StrStpBit[i] );
			for( i = 0; StrFlow[i] != 0; i++ )		SendDlgItemMessage( hwnd, IDC_FLOW, CB_ADDSTRING, 0, (LPARAM)StrFlow[i] );

			if(fFirstSetting == TRUE)
			{
				// Kl(9600bps,8bit,èȂ,įޯ1bit,۰Ȃ)ɐݒ
				SendDlgItemMessage( hwnd, IDC_BAUD, CB_SETCURSEL, 6, 0 );
				SendDlgItemMessage( hwnd, IDC_DATABIT, CB_SETCURSEL, 3, 0 );
				SendDlgItemMessage( hwnd, IDC_PARITY, CB_SETCURSEL, 0, 0 );
				SendDlgItemMessage( hwnd, IDC_STOPBIT, CB_SETCURSEL, 0, 0 );
				SendDlgItemMessage( hwnd, IDC_FLOW, CB_SETCURSEL, 0, 0 );
				fFirstSetting = FALSE;
			}
			else
			{
				SendDlgItemMessage( hwnd, IDC_BAUD, CB_SETCURSEL	, iSetting[0], 0 );
				SendDlgItemMessage( hwnd, IDC_DATABIT, CB_SETCURSEL	, iSetting[1], 0 );
				SendDlgItemMessage( hwnd, IDC_PARITY, CB_SETCURSEL	, iSetting[2], 0 );
				SendDlgItemMessage( hwnd, IDC_STOPBIT, CB_SETCURSEL	, iSetting[3], 0 );
				SendDlgItemMessage( hwnd, IDC_FLOW, CB_SETCURSEL	, iSetting[4], 0 );
			}

			return FALSE ;
	    case WM_COMMAND:
			switch( wParam )
			{
				// uDEFAULTv{^
				case IDB_DEFAULT:
					// Kl(9600bps,8bit,èȂ,įޯ1bit,۰Ȃ)ɐݒ
					SendDlgItemMessage( hwnd, IDC_BAUD, CB_SETCURSEL, 6, 0 );
					SendDlgItemMessage( hwnd, IDC_DATABIT, CB_SETCURSEL, 3, 0 );
					SendDlgItemMessage( hwnd, IDC_PARITY, CB_SETCURSEL, 0, 0 );
					SendDlgItemMessage( hwnd, IDC_STOPBIT, CB_SETCURSEL, 0, 0 );
					SendDlgItemMessage( hwnd, IDC_FLOW, CB_SETCURSEL, 0, 0 );
					return TRUE;
				// uOKv{^
				case IDOK:
					// EOFw
					stDcb.EofChar = 0x00; 

					// {[[gݒ
					iSetting[0] = SendDlgItemMessage( hwnd, IDC_BAUD, CB_GETCURSEL, 0, 0 );
					stDcb.BaudRate = dwBaud[iSetting[0]];
			
					// f[^rbgݒ
					iSetting[1] = SendDlgItemMessage( hwnd, IDC_DATABIT, CB_GETCURSEL, 0, 0 );
					stDcb.ByteSize = byDatBit[iSetting[1]];
			
					// peBrbgݒ
					iSetting[2] = SendDlgItemMessage( hwnd, IDC_PARITY, CB_GETCURSEL, 0, 0 );
					stDcb.Parity = byParity[iSetting[2]]; 
			
					// Xgbvrbgݒ
					iSetting[3] = SendDlgItemMessage( hwnd, IDC_STOPBIT, CB_GETCURSEL, 0, 0 );
					stDcb.StopBits = byStpBit[iSetting[3]];
			
					// t[ݒ
					iSetting[4] = SendDlgItemMessage( hwnd, IDC_FLOW, CB_GETCURSEL, 0, 0 ); 
					switch( iSetting[4] )
					{
						case 0: // ۰Ȃ
							stDcb.fRtsControl = RTS_CONTROL_DISABLE;
							stDcb.fOutX  = FALSE;
							stDcb.fInX   = FALSE;
							break;
						case 1: // ĳ
							stDcb.fRtsControl = RTS_CONTROL_DISABLE;
							stDcb.fOutX  = TRUE;
							stDcb.fInX   = TRUE;
							stDcb.XonChar = 0x11;	// CTRL-Q ]ĊJ邽߂̃R[h
							stDcb.XoffChar = 0x13;	// CTRL-S ]ꎞ~邽߂̃R[h
							stDcb.XonLim = 4;		// ̓obt@̗eʂ4ByteɂȂXono
							stDcb.XoffLim = 12;		// ̓obt@̋󂫗eʂ12ByteɂȂXoffo
							stDcb.fTXContinueOnXoff = FALSE;
							break;
						case 2: // ʰ޳
							stDcb.fRtsControl = RTS_CONTROL_HANDSHAKE;
							stDcb.fOutX  = FALSE;
							stDcb.fInX   = FALSE;
							break;
					}
					EndDialog( hwnd, TRUE );
					return TRUE;
				// uCANCELv{^
				case IDCANCEL:
					EndDialog( hwnd, FALSE );
					return TRUE;
				default:
					return DefWindowProc(hwnd, uMessage, wParam, lParam);
			}
			break;
		default:
			return DefWindowProc(hwnd, uMessage, wParam, lParam);
	}
}

/*******************************************************************************
							bnl|[gN[Y

	Ȃ
߂l
	Ȃ
*******************************************************************************/
void PortClose( void )
{
	if(hCom != NULL)
	{
		CloseHandle( hCom );
		hCom = NULL;
	}
}

/*******************************************************************************
							bnl|[gI[v

	hwnd	: C_CAOEBhEnh
߂l
	TRUE	: I
	FALSE	: G[
*******************************************************************************/
BOOL PortOpen( HWND hwnd )
{
	TCHAR	msg[256];
	TCHAR	port[32];

	sprintf((char *)&szPortName[3], "%d", (int)lPortNumber);

	// PDÂbnl|[gɂ":"Kv
	_tcscat( _tcscpy( port, szPortName ), TEXT(":") );

	// bnl|[gI[v
	hCom = CreateFile( port,							// bnl|[g
						GENERIC_READ|GENERIC_WRITE,		// [hCg
						0,								// foCXLs
						NULL,
						OPEN_EXISTING,
						0,
						NULL);

	if( hCom == NULL || hCom == INVALID_HANDLE_VALUE )
	{	// I[vG[
		wsprintf( msg, TEXT("ERROR: COM Port Open Failure. [code %d]"), GetLastError() );
		MessageBox( hwnd, msg, szAppName, MB_OK | MB_ICONSTOP );
		return FALSE;
	}

	// DCB\̻̂ނ擾
	stDcb.DCBlength = sizeof(stDcb);

	// ݂̐ݒ擾
	if( !GetCommState( hCom, &stDcb) )
	{
		wsprintf( msg, TEXT("ERROR: 'GetCommState()' Function Failed. [code %d]"), GetLastError() );
		MessageBox( hwnd, msg, szAppName, MB_OK | MB_ICONSTOP);

		// bnl|[gN[Y
		PortClose();
		return FALSE;
	}

	return TRUE;
}

/*******************************************************************************
							ʐMݒ聕|[gI[v

	hwnd	: C_CAOEBhEnh
߂l
	TRUE	: I
	FALSE	: G[
*******************************************************************************/
BOOL SetParam( HWND hwnd )
{
	// ʐMݒ_CAO\
	if(DialogBox( hInst, MAKEINTRESOURCE(IDD_SETPRM), hwnd, ( DLGPROC )SetParamDlgProc ) == FALSE)
	{
		return FALSE;
	}

	return TRUE;
}

/*******************************************************************************
									ʐMI

	Ȃ
߂l
	Ȃ
*******************************************************************************/
void Stop( void )
{
	DWORD	code;
	
	if( hThread != INVALID_HANDLE_VALUE)
	{
		// ʐMگނI
		fThread = FALSE;
		// گނ̏Ið擾
		GetExitCodeThread( hThread, &code );
		if(code == STILL_ACTIVE)
		{
			WaitForSingleObject( hThread, 10L );
		}
		// گނ̏I
//		ExitThread( code );

		// گق
		CloseHandle( hThread );

		hThread = INVALID_HANDLE_VALUE;
	}
}

/*******************************************************************************
									ʐMJn

	hwnd	: C_CAOEBhEnh
߂l
	TRUE	: I
	FALSE	: G[
*******************************************************************************/
BOOL Start( HWND hwnd )
{
	TCHAR	msg[256];

	// ʐMp[^ݒ
	if( !SetCommState( hCom, &stDcb) )
	{
		wsprintf( msg, TEXT("ERROR: 'SetCommState()' Function Failed. [code %d]"), GetLastError() );
		MessageBox( hwnd, msg, szAppName, MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}


	// ʐMگ׸ޏ
	fThread = TRUE;
	
	// ʐMگނ쐬܂
	hThread = CreateThread( NULL,
							0, 
							(LPTHREAD_START_ROUTINE)CommThread,
							hwnd, // گނɓnҰ
							0,
							&ThreadId);
	if( hThread == INVALID_HANDLE_VALUE)
	{	// Xbh쐬s
		// ʐMگ׸ޏ
		fThread = FALSE;
		wsprintf( msg, TEXT("ERROR: 'CreateThread()' Function Failed. [code %d]"), GetLastError() );
		MessageBox( hwnd, msg, szAppName, MB_OK | MB_ICONSTOP );
		return FALSE;
	}
	
	return TRUE;
}


/*******************************************************************************
								f[^M

	hwnd	: C_CAOEBhEnh
߂l
	TRUE	: I
	FALSE	: G[
*******************************************************************************/
void Send( HWND hwnd )
{
	DWORD	t;
	
	// f[^擾
	GetDlgItemText( hwnd, IDE_TXDATA, strSendBuf, sizeof(strSendBuf) );
	
	// Ch̕тΉ}`oCg̕тɕϊ
	wcstombs( bySendBuf, strSendBuf, sizeof(bySendBuf) ); 

	// MtOZbg
	fSendFlag = TRUE;

	// M҂
	t = GetTickCount();
	while(fSendFlag == TRUE)
	{
		if((GetTickCount()-t) >= 5000) break;	// M^CAEg
	}
}




/*******************************************************************************
						C_CAOvV[W

	hwnd		: EBhEnh
	uMessage	: bZ[W
	wParam		: ǉ
	lParam		: ǉ
߂l	
*******************************************************************************/
LRESULT CALLBACK MainDlgProc( HWND hwnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{
	TCHAR	pwstr[RECV_BUF_MAX];
	TCHAR	msg[256];
	BOOL	fRes = FALSE;
	SHMENUBARINFO mbi = {0};

	switch (uMessage)
    {
		case WM_INITDIALOG:
			// AXC-SI0xɊ蓖ĂĂCOMԍ擾
			lPortNumber = FindComPort();
			if((lPortNumber < 1) || (lPortNumber > 10))
			{	// AXC-SI0xȂA܂͐ConfigurationĂȂ
				wsprintf( (LPTSTR)msg, TEXT("ERROR: Device Not Found.") );
				MessageBox( hwnd, (LPWSTR)msg, szAppName, MB_OK | MB_ICONSTOP);
				EndDialog( hwnd, FALSE );		// AvP[VI
				break;
			}
			// bnl|[gI[v
			if(PortOpen(hwnd) == FALSE)	EndDialog( hwnd, FALSE );	// AvP[VI
			
			// I[i[CX^Xp̃j[o[𐶐
			mbi.cbSize = sizeof(mbi);
			mbi.hwndParent = hwnd;
			mbi.dwFlags = SHCMBF_EMPTYBAR;
			mbi.hInstRes = hInst;
			fRes = SHCreateMenuBar(&mbi);
			
			// ʐMݒ_CAOI[vpɃbZ[W|Xg
			EnableWindow( GetDlgItem(hwnd,IDB_SETTING), FALSE );
			PostMessage( hwnd, WM_COMMAND, IDD_SETPRM, 0L );
			break;

		case WM_RECVDATA:
			// }`oCg̕тΉ郏Ch̕тɕϊ
			memset( pwstr, 0x00, sizeof(pwstr) );
			mbstowcs( pwstr, (char *)wParam, lParam );

			if( _tcslen(strRecvBuf) + lParam >= STR_BUF_MAX )
			{
				memset( strRecvBuf, 0x00, sizeof(strRecvBuf) );
			}
			_tcscat( strRecvBuf, pwstr );

			// Mf[^\
			SetDlgItemText( hwnd, IDE_RXDATA, strRecvBuf );
						
			GlobalFree( (BYTE *)wParam );
			break;

		case WM_COMMAND:
			switch( LOWORD(wParam) )
			{
				case IDD_SETPRM:
					// ʐMݒ
					if(SetParam(hwnd) == FALSE)
					{
						// AvP[VI
						PostQuitMessage( 0 );
					}
					else
					{
						EnableWindow(GetDlgItem(hwnd,IDB_SETTING),TRUE);

						// ʐMJn
						if(Start(hwnd) == FALSE)
						{
							// ʐMݒ_CAOI[vpɃbZ[W|Xg
							PostMessage( hwnd, WM_COMMAND, IDD_SETPRM, 0L );
						}
					}
					break;
		        case IDB_TXDATA:
					// f[^M
					Send(hwnd);
		            break;
				case IDB_CLEAR:
					// \NA
					SetDlgItemText( hwnd, IDE_TXDATA, L"" );
					SetDlgItemText( hwnd, IDE_RXDATA, L"" );
					memset(strRecvBuf,0x00,sizeof(strRecvBuf));
					break;
				case IDB_SETTING:
					// ʐMI
					Stop();
					// \NA
					SetDlgItemText( hwnd, IDE_TXDATA, L"" );
					SetDlgItemText( hwnd, IDE_RXDATA, L"" );
					memset(strRecvBuf,0x00,sizeof(strRecvBuf));
					// ʐMݒ_CAOI[vpɃbZ[W|Xg
					PostMessage( hwnd, WM_COMMAND, IDD_SETPRM, 0L );
					break;
				case IDCANCEL:
					// ʐMI
					Stop();
					// COM߰ĸ۰
					PortClose();
					// I
					EndDialog( hwnd, FALSE );
					break;
				default:
					return DefWindowProc( hwnd, uMessage, wParam, lParam );
			}
			return FALSE;
	    default:
		    return DefWindowProc( hwnd, uMessage, wParam, lParam );
    }

    return FALSE;
}
														
/*******************************************************************************
					֐̌Ăяoүٰߏ

	hInstance		: ݂̲ݽݽ
 	hPrevInstance	: ȑO̲ݽݽ
	lpszCmdLine     : ײ
	nCmdShow        : \
߂l	
	PostQuitMessage֐̖߂l
*******************************************************************************/
int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPWSTR lpCmdLine, int nCmdShow )
{
	HANDLE	hMutex;
	hInst = hInstance;

	// AvP[V̓dN}~
	hMutex = CreateMutex( NULL, TRUE, szAppName );
	if( GetLastError() == ERROR_ALREADY_EXISTS ) return FALSE;
	
	// bnl|[gnh
	hCom = NULL;			

	// MtO
	fSendFlag = FALSE;

	// ʐMݒtO
	fFirstSetting = TRUE;
	memset(strRecvBuf,0x00,sizeof(strRecvBuf));

	// [__CAO{bNX쐬
	DialogBox( hInstance, MAKEINTRESOURCE( IDD_MAIN ), NULL, ( DLGPROC )MainDlgProc );
	return FALSE;
}
